HDU 3152 Obstacle Course(BFS+优先队列 重载)

题目链接:http://acm.hdu.edu.cn/showproblem.php?

pid=3152


Problem Description


You are working on the team assisting with programming for the Mars rover. To conserve energy, the rover needs to find optimal paths across the rugged terrain to get from its starting location to its final location. The following is the first approximation for the problem.


N * N square matrices contain the expenses for traversing each individual cell. For each of them, your task is to find the minimum-cost traversal from the top left cell [0][0] to the bottom right cell [N-1][N-1]. Legal moves are up, down, left, and right; that is, either the row index changes by one or the column index changes by one, but not both.
 
Input
Each problem is specified by a single integer between 2 and 125 giving the number of rows and columns in the N * N square matrix. The file is terminated by the caseN = 0.

Following the specification of N you will find N lines, each containing N numbers. These numbers will be given as single digits, zero through nine, separated by single blanks.
 
Output
Each problem set will be numbered (beginning at one) and will generate a single line giving the problem set and the expense of the minimum-cost path from the top left to the bottom right corner, exactly as shown in the sample output (with only a single space after "Problem" and after the colon).
 
Sample Input
3 5 5 4 3 9 1 3 2 7 5 3 7 2 0 1 2 8 0 9 1 1 2 1 8 1 9 8 9 2 0 3 6 5 1 5 7 9 0 5 1 1 5 3 4 1 2 1 6 5 3 0 7 6 1 6 8 5 1 1 7 8 3 2 3 9 4 0 7 6 4 1 5 8 3 2 4 8 3 7 4 8 4 8 3 4 0
 
Sample Output
Problem 1: 20 Problem 2: 19 Problem 3: 36
 
Source

题意:
从左上到右下的路径中。寻找一条经过的格子中的数字之和最小的路径。

移动方向能够上、下、左、右。

PS:

因为曾经做过HDU2084,所以第一感觉是用DP来做,可是此题能够再走已经走过的点,

所以仅仅实用记忆化搜索。

优先队列优化。


代码例如以下:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <queue>
#include <vector>
using namespace std;
const int maxn = 177;
struct node
{
    int x, y;
    int dis;
    bool operator<(const node &s)const
    {
        return dis > s.dis;
    }
};
int n;
int mm[maxn][maxn];
int vis[maxn][maxn];
int dx[4] = {1,0,-1,0};
int dy[4] = {0,-1,0,1};
int BFS(int dis)
{
    priority_queue<node> q;
    node fro, pre;
    fro.x = 0, fro.y = 0;
    fro.dis = dis;
    q.push(fro);
    while(!q.empty())
    {
        fro = q.top();
        q.pop();
        for(int i = 0; i < 4; i++)
        {
            int xx = fro.x+dx[i];
            int yy = fro.y+dy[i];
            if(xx>=0&&xx<n&&yy>=0&&yy<n)
            {
                pre.x = xx, pre.y = yy;
                pre.dis = fro.dis + mm[xx][yy];
                if(vis[xx][yy]==-1||vis[xx][yy]>pre.dis)
                {
                    //没有訪问过,或者当前的不是最短的
                    vis[xx][yy] = pre.dis;
                    if(xx!=n-1 || yy!=n-1)
                        q.push(pre);
                }
            }
        }
    }
    return vis[n-1][n-1];
}
int main()
{
    int cas = 0;
    while(scanf("%d",&n)&&n)
    {
        memset(vis,-1,sizeof(vis));
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++)
            {
                scanf("%d",&mm[i][j]);
            }
        }
        int ans = BFS(mm[0][0]);
        printf("Problem %d: %d
",++cas,ans);
    }
    return 0;
}


原文地址:https://www.cnblogs.com/wgwyanfs/p/6918651.html